Index: trunk/kernel/syscalls/sys_getcwd.c
===================================================================
--- trunk/kernel/syscalls/sys_getcwd.c	(revision 690)
+++ trunk/kernel/syscalls/sys_getcwd.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_getcwd.c - kernel function implementing the "getcwd" syscall.
+ * kern/sys_getcwd.c - get process current work directory
  * 
- * Author    Alain Greiner (2016,2017,2018,2019)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c)  UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,105 +17,51 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <hal_special.h>
-#include <errno.h>
+#include <libk.h>
 #include <vfs.h>
-#include <vmm.h>
-#include <process.h>
+#include <sys-vfs.h>
+#include <task.h>
+#include <kmem.h>
+#include <ppm.h>
 #include <thread.h>
-#include <printk.h>
 
-#include <syscalls.h>
+/* TODO: user page need to be locked as long as its region */
 
-///////////////////////////////////
-int sys_getcwd ( char     * buffer,
-                 uint32_t   nbytes )
+int sys_getcwd (char *buff, size_t size)
 {
-	error_t       error;
-    vseg_t      * vseg;
-    char        * first;                   // first character valid in buffer
+	register struct thread_s *this;
+	register struct task_s *task;
+	register error_t err;
+	struct ku_obj ku_buff;
+  
+	this      = current_thread;
+	task      = current_task;
 
-    char          kbuf[CONFIG_VFS_MAX_PATH_LENGTH]; 
-
-	thread_t  * this    = CURRENT_THREAD;
-    process_t * process = this->process;
-
-#if (DEBUG_SYS_GETCWD || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-    // check buffer size
-	if( nbytes < CONFIG_VFS_MAX_PATH_LENGTH )
+	if((size < VFS_MAX_NAME_LENGTH) || (!buff)) 
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : buffer too small for thread %x,%x]\n",
-__FUNCTION__ , process->pid, this->trdid );
-#endif
-		this->errno = EINVAL;
-        return -1;
+		err = ERANGE;
+		goto SYS_GETCWD_ERROR;
 	}
 
-    // check buffer in user space
-    error = vmm_get_vseg( process, (intptr_t)buffer , &vseg );
-
-	if( error )
+	if(vmm_check_address("usr cwd buffer", task, buff, size))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-printk("\n[ERROR] in %s : user buffer unmapped %x for thread[%x,%x]\n",
-__FUNCTION__ , (intptr_t)buffer , process->pid, this->trdid );
-#endif
-		this->errno = EINVAL;
-        return -1;
+		err = EFAULT;
+		goto SYS_GETCWD_ERROR;
 	}
 
-#if DEBUG_SYS_GETCWD
-if( DEBUG_SYS_GETCWD < tm_start )
-printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, (uint32_t)tm_start );
-#endif
+	KU_SZ_BUFF(ku_buff, buff, size);
 
-    // get extended pointer on CWD inode from the reference process
-    xptr_t      ref_xp  = process->ref_xp;
-    process_t * ref_ptr = GET_PTR( ref_xp );
-    cxy_t       ref_cxy = GET_CXY( ref_xp );
-    xptr_t      cwd_xp  = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->cwd_xp ) );
+	rwlock_rdlock(&task->cwd_lock);
 
-    // call relevant VFS function
-	error = vfs_get_path( cwd_xp,
-                          kbuf, 
-                          &first, 
-                          CONFIG_VFS_MAX_PATH_LENGTH );
+	err = vfs_get_path(&task->vfs_cwd, &ku_buff);
 
-    // copy kernel buffer to user space
-    hal_strcpy_to_uspace( buffer, 
-                          XPTR( local_cxy , first ),
-                          CONFIG_VFS_MAX_PATH_LENGTH );
+	rwlock_unlock(&task->cwd_lock);
 
-    hal_fence();
 
-#if (DEBUG_SYS_GETCWD || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_GETCWD
-if( DEBUG_SYS_GETCWD < tm_end )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_GETCWD] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_GETCWD] , 1 );
-#endif
-
-	return 0;
-
-}  // end sys_getcwd()
+SYS_GETCWD_ERROR:
+	this->info.errno = err;
+	return (int)buff;
+}
